/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : pon sie 13 18:14:52 CEST 2001
    copyright            : (C) 2001 by Jakub Madej
    email                : madqba@kki.net.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include <qapplication.h>
#include <qfont.h>
#include <qstring.h>
#include <qtextcodec.h>
#include <qtranslator.h>
#include <qtoolbutton.h>
#include <qdir.h>
#include <qcheckbox.h>
#include <qlineedit.h>
#include <qfiledialog.h>
#include <qlabel.h>
#include <qpixmap.h>
#include <qprogressbar.h>

#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <linux/soundcard.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>

#include "stilview/stil.h"
#include "saplib/sapLib.h"

#include "saper.h"


sapMUSICstrc *currentFile;

STIL myStil;

signed short buffer[88200/16];
const int dataSize=22050/4/16;
int fd;
bool ifplaygl;
FILE *f;
char testBuf[1000];
char* globapath;
bool globifas;
QString configfile;
bool blockt=TRUE;
bool wasrew=FALSE;
long rewcontrol;

void Form2::showme()
{
	if (this->isVisible()==FALSE)	
		show();
	else
		hide();
	if (globifas)
		TextLabel9->setNum(myStil.getSTILVersionNo());
	if ((myStil.getSTILVersionNo()==0) || (globifas==FALSE))
		 TextLabel9->setText("N/A");
}

const char* checkbug(char* filepath)
{
	char testBuf[1000];
	FILE *buglist;
	QString tmppath;
	char* buginfo;
	char testcompareBuf[1000];
	char fininfo[1000];
	char* staticinfo;
	int breakpos;
	
	for (unsigned int i=0; i<strlen(filepath); i++)
					if (filepath[i]=='/') breakpos=i;
					
	for (unsigned int i=0; i<(strlen(filepath)-breakpos); i++)
					testcompareBuf[i]=filepath[i+breakpos+1];

	
	tmppath=globapath;
	tmppath+="Docs/Bugs.txt";
	buglist=fopen(tmppath, "r+");
	for (int i=0; i<100; i++)
	{
		fgets((char *)testBuf, 1000, buglist);
		buginfo=strstr(testBuf,testcompareBuf);
		if (buginfo!=NULL) break;
	}
	
	if (buginfo!=NULL)
		for (unsigned int i=0; i<100; i++)
					fininfo[i]=buginfo[i+strlen(testcompareBuf)+3];
					
	fclose(buglist);
	staticinfo=strdup(fininfo);
	
	if (buginfo!=NULL) return staticinfo;
	else return NULL;
}

void Form1::setfilename()
{
			tytul="";
			if (globifas)
				for (unsigned int i=0; i<(strlen(file2play)-strlen(globapath)); i++)
					tytul+=file2play[strlen(globapath)+i];
			else
				tytul=file2play;
			TextLabel5->setText(tytul);
}


void Form1::showstil(int tstate)
{
	if (tstate==2)
		{
	  	QRect rect;
			rect = this->frameGeometry();
	  	stilview->setGeometry(this->x()+rect.width(),this->y(), 302,261 );
	  	if (songs!=-2)
	  		stilview->setLabels(myStil.getAbsGlobalComment(file2play),myStil.getAbsEntry(file2play,cursong),(char *)checkbug(file2play));
	    else
	      stilview->setLabels("*** NO STIL ENTRY AVAIBLE ***","*** NO STIL ENTRY AVAIBLE ***",0);
	  }
	if (tstate==0)
		stilview->hide();
}

void Form1::filedialoginit()
{
	if (myFileDlg->isVisible()==FALSE)
	{
    if (globifas)
    	myFileDlg->setDir(config->returnapath());
		myFileDlg->show();
	}
	else
	{
		myFileDlg->hide();
	}
}


void Form3::ok()
{
	QString tmp;
	ifasma=CheckBox1->isChecked();
	asmapath=LineEdit1->text();
	globapath = strdup( asmapath );
	if (!myStil.setBaseDir(globapath))
	{
		ifasma=FALSE;
		globifas=FALSE;
		CheckBox1->setChecked(FALSE);
	}
	hide();
	creat(configfile,0x0180);
	freopen(configfile,"r+",f);
	tmp="ENABLEAS=";
	if (ifasma==TRUE)
			tmp+="YES";
	else
		tmp+="NO";
	globifas=ifasma;
	fputs(tmp,f);
	fputs("\n",f);
	tmp="ASMAPATH=";
	tmp+=globapath;
	fputs(tmp,f);
	fputs("\n",f);
}

const char* Form3::returnapath()
{
	return (const char*)globapath;
}

void Form3::loadconfig()
{
	rewind(f);
	ifasma=FALSE;
	asmapath="";
	fgets((char *)testBuf, 1000, f);
	if (testBuf[9]=='Y')
	 	ifasma=TRUE;
	globifas=ifasma;
	CheckBox1->setChecked(ifasma);
	fgets((char *)testBuf, 1000, f);
	for(int i=9; testBuf[i]!='\n' ; i++)
	  		asmapath+=testBuf[i];
	LineEdit1->setText(asmapath);
	globapath = strdup( asmapath );
	myStil.setBaseDir(globapath);
}

void MainThread::run()
{
	while (blockt)
	{		
			if (ifplaygl)
			{
				sapRenderBuffer(buffer, dataSize/4);
				write(fd, buffer, dataSize);
			}	
	}
}

void Form1::sapstop()
{
	killpause();
	this->czas=-1;
	this->mins=0;
	this->timerDone();
	ifplay=FALSE;
	currentFile = sapLoadMusicFile( file2play );
	cursong=currentFile->defSong;
	sapsongs();
}

void Form1::doprocess()
{
    if ((checkrewpressed()==FALSE) && (wasrew==TRUE))
		{
			long tmpcontr=rewcontrol-128;
			if (rewprogresswidget->progress()==-1)
			{
				currentFile = sapLoadMusicFile( file2play );
				sapPlaySong(cursong);
			}
			ifplay=FALSE;
			ifplaygl=FALSE;
			rewprogresswidget->show();

			for (int i=1; i<128 ;i++)
					sapRenderBuffer(buffer, 22050/4/4);	
      rewcontrol=rewcontrol-128;
			rewprogresswidget->setProgress(rewprogresswidget->progress() + 128);
			
			if (rewcontrol<=0)
			{
				wasrew=FALSE;
				ifplay=TRUE;
				ifplaygl=TRUE;
				rewprogresswidget->hide();
			}
			return;
		}

		if (stilview->isVisible()==FALSE)
    	ToolButton3_2_2_3_2_3->setOn(FALSE);

    if (this->checkforwardpress()==TRUE)
    {
  		ifplaygl=FALSE;
  		for (int i=1; i<40; i++)
			{
  			sapRenderBuffer(buffer, 22050/4/4);
 			}
	
			usleep(1);

			this->timerDone();
			if (ifplay==FALSE)
      	sapstart();
      ifplaygl=TRUE;
		}

		if (checkrewpressed()==TRUE)
		{
			ifplay=TRUE;
			wasrew=TRUE;
			czas=(czas-2);
			if (czas<0)
			{
				czas=58;
				mins--;
				if (mins<0)
				{
					mins=0;
					czas=-1;
				}
			}
			timerDone();
			ifplay=FALSE;
			if ((czas<=0) && (mins==0))
				{
					ifplay=TRUE;
					wasrew=FALSE;
					ToolButton3_2_2_2_2_2->setDown(FALSE);
					czas=-1;
					currentFile = sapLoadMusicFile( file2play );
					sapPlaySong(cursong);
				}
			usleep(50000);
			rewcontrol=long((czas+(60*mins))*32);
			rewprogresswidget->setTotalSteps(int(rewcontrol));
			rewprogresswidget->reset();
		}
		


		ifplaygl=ifplay;
		ToolButton3_2_2_3_2_3->setEnabled(globifas);
		if (!globifas && stilview->isVisible())
			 stilview->hide();
}

void Form1::setprevsongexec()
{
	sapPlaySong(cursong);
}

void Form1::playFile(const QString& nowyplik)
{	
	if (mythread->running())
	{	
		blockt=FALSE;
		mythread->wait();
	}
	file2play=strdup((const char*)nowyplik);
	setfilename();
	getinfo();
	sapstop();
	setplaybuttstate();
	songs=currentFile->numOfSongs;
	cursong=currentFile->defSong;
	if (globifas && stilview->isVisible())
  	stilview->setLabels(myStil.getAbsGlobalComment(file2play),myStil.getAbsEntry(file2play,cursong),(char *)checkbug(file2play));
	sapsongs();

	czas=-1;
	mins=0;
	this->ifplay=TRUE;
	blockt=TRUE;
	if (!mythread->running())
		mythread->start();
}


int main(int argc, char *argv[])
{	
	configfile=QDir::homeDirPath();
  configfile+="/.saper";
	 f=fopen(configfile, "r+");
	 if (f==NULL)
	 {
	 		creat(configfile,0x0180);
			f=fopen(configfile,"r+");
			fputs("ENABLEAS=NO\n",f);
			fputs("ASMAPATH=/\n",f);
	 }	
	 QApplication a(argc, argv);
	 a.setFont(QFont("helvetica", 10));

	 Form1 *saper=new Form1();

	 a.setMainWidget(saper);
	
   fflush(stdout);


  int format;	
	fd=open("/dev/mixer", O_WRONLY, 0);
	fd=open("/dev/dsp", O_WRONLY, 0);
	format=AFMT_S16_LE;
	ioctl(fd, SNDCTL_DSP_SETFMT, &format);
	format=44100;
	ioctl(fd, SNDCTL_DSP_SPEED, &format);
	format=2;
	ioctl(fd, SNDCTL_DSP_CHANNELS, &format);
	
   if (argc>1)
   {			
			for(int x=1;x<argc;x++)
			{
				saper->file2play=argv[x];
			}			
	 }

if ((sapLoadMusicFile(saper->file2play)!=NULL))
	{	
			saper->playFile(saper->file2play);
		  saper->show();
			a.exec();
			fclose(f);
			exit(0);
	}

if (argc<=1)
	{
		saper->show();
		a.exec();
		fclose(f);
		exit(0);
	}

cout << "Invalid file. Quiting...\n";
fclose(f);
exit(0);
}
